Virtualization in Angular File Manager component

18 Nov 20185 minutes to read

File Manager’s UI virtualization optimizes performance by dynamically loading only the visible files and directories in the viewport instead of rendering the entire collection at once. This significantly improves loading times and reduces memory consumption when handling large numbers of files and directories in both detailsView and largeIconsView.

Module Injection

To implement UI virtualization, import the VirtualizationService module in your AppModule and inject it into the provider section as follows:

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { FileManagerComponent, VirtualizationService } from '@syncfusion/ej2-angular-filemanager';

@NgModule({
    imports: [
        BrowserModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [VirtualizationService]
})
export class AppModule { }

Enable Virtualization

The File Manager’s virtualization feature dynamically renders items based on the current viewport dimensions. As users scroll through content in either largeIconsView or detailsView, only the visible items are loaded, while others are rendered on demand.

To enable virtualization, set the enableVirtualization property to true. This is especially recommended when working with directories containing hundreds or thousands of files.

Implementation Example

The following example demonstrates virtualization with a large collection of files in the ‘Documents’ and ‘Text Documents’ folders:

import { BrowserModule } from '@angular/platform-browser'
import { NgModule } from '@angular/core'
import { FileManagerModule, NavigationPaneService, ToolbarService, DetailsViewService, VirtualizationService } from '@syncfusion/ej2-angular-filemanager'
import { Component, ViewEncapsulation } from '@angular/core';
/**
 * File Manager virtualization feature sample
 */

@Component({
    imports: [FileManagerModule,],
    standalone: true,
    selector: 'app-root',
    styleUrls: ['./app.component.css'],
    templateUrl: './default.html',
    encapsulation: ViewEncapsulation.None,
    providers: [NavigationPaneService, ToolbarService, DetailsViewService, VirtualizationService]
})

export class AppComponent {
    public ajaxSettings?: object;
    public view?: string;
    public hostUrl: string = 'https://physical-service.syncfusion.com/';
    public ngOnInit(): void {
        this.ajaxSettings = {
            url: this.hostUrl + 'api/Virtualization/FileOperations',
            getImageUrl: this.hostUrl + 'api/Virtualization/GetImage',
            uploadUrl: this.hostUrl + 'api/Virtualization/Upload',
            downloadUrl: this.hostUrl + 'api/Virtualization/Download'
        };
        this.view = "Details";
    }

    onBeforeSend(args: any) {
        args.ajaxSettings.beforeSend = function (args: any) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    }
    beforeImageLoad(args: any) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    }
    beforeDownload(args: any) {
        args.data.rootFolderName = 'FileBrowser';
    }
}
@import "node_modules/@syncfusion/ej2-material3-theme/styles/file-manager/index.css";
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

When to Use Virtualization

Virtualization is particularly beneficial in the following scenarios:

  • File systems with hundreds or thousands of files in a single directory
  • Applications where File Manager needs to load quickly without performance degradation
  • Environments with limited memory resources where rendering large collections could impact performance

Limitations for Virtualization

When implementing virtualization in the File Manager, be aware of these limitations:

  • Programmatic selection using the selectAll method is not supported with virtual scrolling.

  • The keyboard shortcut CTRL+A will only select the files and directories that are currently visible within the viewport, rather than selecting all files and directories in the entire directory tree.

  • Selected file items are not maintained while scrolling to optimize component performance.

Virtualization in React File Manager component

18 Nov 201810 minutes to read

File Manager’s UI virtualization allows you for the dynamic loading of a large number of directories and files in both the detailsView and largeIconsView without degrading its performance.

Module Injection

In order to use UI Virtualization, you need to inject its virtualization service in the App. This modules should be injected into the File Manager using the Inject directive.

import { FileManagerComponent, Inject, Virtualization } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';

function App() {
    let hostUrl: string = "https://physical-service.syncfusion.com/";
    return (
            // specifies the tag to render the File Manager component
            <FileManagerComponent id="filemanager" ajaxSettings={{
                    url: hostUrl + "api/FileManager/FileOperations",
                    getImageUrl: hostUrl + "api/FileManager/GetImage",
                    uploadUrl: hostUrl + 'api/FileManager/Upload',
                    downloadUrl: hostUrl + 'api/FileManager/Download'
                }} enableVirtualization={true}>
                    <Inject services={[Virtualization]}/>
                </FileManagerComponent>
        );
}
export default App;

Enable Virtualization

The virtualization of the File Manager component is based on the height and width of the viewport. The items will be loaded in both largeIconsView and detailsView based on the viewport size.

In order to enable virtualization, you must set the enableVirtualization property to true.

In the instance below, a sizable collection of files can be found in the folders Documents and Text Documents.

import { FileManagerComponent, Inject, NavigationPane, DetailsView, Toolbar, Virtualization } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';
/**
 * File Manager virtualization feature sample
 */
function App() {
    let hostUrl = "https://physical-service.syncfusion.com/";
    let height = "375px";
    let view = "Details";
    let enableVirtualization = true;
    let ajaxSettings = {
        url: hostUrl + "api/Virtualization/FileOperations",
        getImageUrl: hostUrl + "api/Virtualization/GetImage",
        uploadUrl: hostUrl + 'api/Virtualization/Upload',
        downloadUrl: hostUrl + 'api/Virtualization/Download'
    };
    function onBeforeSend(args) {
        args.ajaxSettings.beforeSend = function (args) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    }
    function beforeImageLoad(args) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    }
    function beforeDownload(args) {
        args.data.rootFolderName = 'FileBrowser';
    }
    return (<div>
            <div className="control-section">
                <FileManagerComponent id="filemanager" height={height} 
                    ajaxSettings={ajaxSettings} 
                    view={view} 
                    enableVirtualization={enableVirtualization} 
                    beforeSend={onBeforeSend.bind(this)} 
                    beforeImageLoad={beforeImageLoad.bind(this)} 
                    beforeDownload={beforeDownload.bind(this)}>
                    <Inject services={[NavigationPane, DetailsView, Toolbar, Virtualization]}/>
                </FileManagerComponent>
            </div>
        </div>);
}
export default App;
import { FileManagerComponent, Inject, NavigationPane, DetailsView, Toolbar, Virtualization } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';
/**
 * File Manager virtualization feature sample
 */
function App() {

    let hostUrl: string = "https://physical-service.syncfusion.com/";
    let height: string = "375px";
    let view: string = "Details";
    let enableVirtualization: boolean = true;
    let ajaxSettings: object = {
        url: hostUrl + "api/Virtualization/FileOperations",
        getImageUrl: hostUrl + "api/Virtualization/GetImage",
        uploadUrl: hostUrl + 'api/Virtualization/Upload',
        downloadUrl: hostUrl + 'api/Virtualization/Download'
    };
    function onBeforeSend(args) {
        args.ajaxSettings.beforeSend = function (args) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    }
    function beforeImageLoad(args) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    }
    function beforeDownload(args) {
        args.data.rootFolderName = 'FileBrowser';
    }
    return(
        <div>
            <div className="control-section">
                <FileManagerComponent id="filemanager" height={height} 
                    ajaxSettings={ajaxSettings}
                    view={view}
                    enableVirtualization={enableVirtualization}
                    beforeSend={onBeforeSend.bind(this)}
                    beforeImageLoad={beforeImageLoad.bind(this)}
                    beforeDownload={beforeDownload.bind(this)}>
                <Inject services={[ NavigationPane, DetailsView, Toolbar, Virtualization]} />
                </FileManagerComponent>
            </div>
        </div>
    );
};
export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';

ReactDOM.render( <App />, document.getElementById('root') as HTMLElement);

Limitations for Virtualization

  • Programmatic selection using the selectAll method is not supported with virtual scrolling.

  • The keyboard shortcut CTRL+A will only select the files and directories that are currently visible within the viewport, rather than selecting all files and directories in the entire directory tree.

  • Selected file items are not maintained while scrolling, considering the performance of the component.